#include <stdio.h>

/**
 * Simple example of an arbitrary write that allows comrpomising a function
 * pointer. Compile with 
 * `clang -Wall -Wpedantic -Wextra skeleton.c -flto -O0 skeleton.c`, then play
 * with `-fsanitize=cfi`.
 * Discover the offset through `objdump -d ./a.out` and look at the difference
 * between welcome and notcalled. Add this offset when running the program.
 */

__attribute__((noinline)) void welcome(void) {
  printf("We're at 0x%lx. Happy arbitrary offset: ", (unsigned long)&welcome);
}

__attribute__((noinline)) void notcalled(void) {
  printf("This function is never called.\n");
}

int main(void) {
  /* welcome is address taken and assigned to the function pointer */
  void (*ptr)(void) = &welcome;
  long offset;

  /* call welcome function through function pointer */
  ptr();

  /* allow illegal modification of ptr through "attacker"-controlled value */
  scanf("%ld", (long int*)&offset);
  ptr = (void(*)(void))((long)ptr + offset);

  /* ptr has now been compromised */
  ptr();

  return 0;
}
